require 'thor'
require 'dotpack/cli/flavor'
require 'dotpack/cli/repo'
require 'dotpack/package'
require 'dotpack/runner'

module Dotpack
  module Cli
    class App < Thor
      register(Cli::Flavor, 'flavor', 'flavor <command>', 'Add, remove or list flavors')
      register(Cli::Repo, 'repo', 'repo <command>', 'Manage repositories')

      desc "relink", "Create or recreate dotfiles and link them"
      def relink
        Runner.clear
        runner = Runner.new
        Package.all.each do |package|
          runner.start package
        end
      end

      desc "update", "Update the dotfiles from source"
      def update
        repos = Dotpack::Repo.all
        relink if repos.map(&:update).any?
      end

      desc "clear", "Clear every symlink"
      def clear
        Runner.clear
      end
    end
  end
end
