require 'thor'
require 'colorize'
require 'dotpack/config'

module Dotpack
  module Cli
    class Flavor < Thor
      desc('add FLAVOR [VALUE]', 'Add flavor.')
      def add(f, value='')
        f = f.downcase
        Config.set_flavor(f, value)
        Config.save
      end

      desc('remove FLAVOR', 'Remove flavor.')
      def remove(f)
        f = f.downcase
        Config.remove_flavor f
        Config.save
      end

      desc('list', 'List used flavors.')
      def list
        Config.flavors.each do |k, v|
          if v == '' || v.nil?
            puts k
          else
            puts "#{k} = #{v}"
          end
        end
      end
    end
  end
end
