require 'thor'
require 'dotpack/repo'

module Dotpack
  module Cli
    class Repo < Thor
      desc "list", "List installed repositories"
      def list
        ::Dotpack::Repo.all.each{|r| puts r.name}
      end

      desc "clone [ARG]", "Clone a new repository"
      def clone(arg)
        # Cache
        Dotpack::Repo.all
        
        url = arg
        name = arg.split('/').last
        if name.include? ".git"
          name[".git"] = ''
        end
        if arg =~ /\A[a-zA-Z0-9_-]+\/[\.a-zA-Z0-9_-]+\z/
          url = "https://github.com/#{arg}.git"
          name = arg.sub('/', '__')
        end
        Dir.chdir Config::BASE_DIR + '/repositories'
        return if Dir.exist? name
        system("git", "clone", url, name)
      end

      desc "remove [ARGS]", "Remove repositories"
      def remove(*args)
        args.each do |repo|
          r = ::Dotpack::Repo.find_by_name repo
          next if r.nil?
          FileUtils.rm_rf r.path
        end
      end
    end
  end
end
